%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib(1))")}

%{!?nosetest_path: %global nosetest_path "/tmp"}

Name:           fts-rest
Version:        3.8.3
Release:        1%{?dist}
BuildArch:      noarch
Summary:        FTS3 Rest Interface
License:        ASL 2.0
URL:            http://fts3-service.web.cern.ch/
# git clone https://gitlab.cern.ch/fts/fts-rest.git --depth 1 -b master fts-rest-3.7.1
# cd fts-rest-3.7.1
# git checkout v3.7.1
# cd ..
# tar vczf fts-rest-3.7.1.tar.gz --exclude-vcs fts-rest-3.7.1
Source0:        %{name}-%{version}.tar.gz 

BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gfal2-python
BuildRequires:  gfal2-plugin-mock
BuildRequires:  cmake
BuildRequires:  python-jsonschema
%if %{?rhel}%{!?rhel:0} == 6
BuildRequires:  python-nose1.1
%else
BuildRequires:  python-nose
%endif
BuildRequires:  python-dateutil
BuildRequires:  python-pylons
BuildRequires:  scipy
BuildRequires:  m2crypto
BuildRequires:  python-mock
BuildRequires:  python-m2ext
%if %{?fedora}%{!?fedora:0} >= 17 || %{?rhel}%{!?rhel:0} >= 7
BuildRequires:  python-sqlalchemy
%else
BuildRequires:  python-sqlalchemy0.8
%endif
BuildRequires:  python-requests
%if %{?rhel}%{!?rhel:0} == 6 
BuildRequires:  python-slimit
%endif
BuildRequires:  pandoc
BuildRequires:  python-dirq

Requires:       gridsite%{?_isa} >= 1.7
Requires:       httpd%{?_isa}
Requires:       mod_wsgi
Requires:       python-dirq
Requires:       python-fts = %{version}-%{release}
Requires:       python-paste-deploy
Requires:       python-pylons
Requires:       python-simplejson%{?_isa}
Requires:       gfal2-python%{?_isa}
Requires:       python-requests

%description
This package provides the FTS3 REST interface

%if %{?rhel}%{!?rhel:0} >= 7 || %{?fedora}%{!?fedora:0} >= 28
%package firewalld
Summary: FTS3 Rest Firewalld
Group: Applications/Internet

Requires:  firewalld-filesystem

%description firewalld
FTS3 Rest firewalld.
%endif

%package cloud-storage
Summary:        FTS3 Rest Cloud Storage extensions
Requires:       fts-rest = %{version}-%{release}

%description cloud-storage
FTS3 Rest Cloud Storage extensions. Includes support for Dropbox

%package oauth2
Summary:        FTS3 Rest OAuth2 provider
Requires:       fts-rest = %{version}-%{release}

%description oauth2
FTS3 Rest OAuth2 provider

%package http-authz-signed-cert
Summary:        FTS3 Rest HTTP_AUTHORIZATION signed-cert method
Requires:       python-dateutil
Requires:       python-m2ext
Requires:       fts-rest = %{version}-%{release}

%description http-authz-signed-cert
FTS3 Rest HTTP_AUTHORIZATION signed-cert method

%package cli
Summary:        FTS3 Rest Interface CLI
Requires:       python-fts = %{version}-%{release}
Requires:       python-m2ext

%description cli
Command line utilities for the FTS3 REST interface

%package selinux
Summary:        SELinux support for fts-rest
Requires:       %{name} = %{version}-%{release}

%description selinux
SELinux support for fts-rest

%if %{?fedora}%{!?fedora:0} >= 28
%package -n python2-fts
%{?python_provide:%python_provide python2-fts}
%else
%package -n python-fts
%endif
Summary:        FTS3 database model
Requires:       m2crypto
Requires:       python-pycurl
%if %{?fedora}%{!?fedora:0} >= 17 || %{?rhel}%{!?rhel:0} >= 7
Requires:       python-sqlalchemy
%else
Requires:       python-sqlalchemy0.8
%endif

%if %{?fedora}%{!?fedora:0} >= 28
%description -n python2-fts
%else
%description -n python-fts
%endif
This package provides an object model of the FTS3
database, using sqlalchemy ORM.

%post
/sbin/service httpd condrestart >/dev/null 2>&1 || :
if [ "$1" -eq "2" ]; then # Upgrade
    # 3.5.1 needs owner to be fts3, since fts3rest runs as fts3
    chown fts3.fts3 /var/log/fts3rest
    chown fts3.fts3 /var/log/fts3rest/fts3rest.log || true
fi

%postun
if [ "$1" -eq "0" ] ; then
    /sbin/service httpd condrestart >/dev/null 2>&1 || :
fi

%post selinux
if [ "$1" -le "1" ] ; then # First install
semanage port -a -t http_port_t -p tcp 8446
setsebool -P httpd_can_network_connect=1
setsebool -P httpd_setrlimit=1
semanage fcontext -a -t httpd_log_t "/var/log/fts3rest(/.*)?"
restorecon -R /var/log/fts3rest/
fi

%preun selinux
if [ "$1" -lt "1" ] ; then # Final removal
semanage port -d -t http_port_t -p tcp 8446
setsebool -P httpd_can_network_connect=0
setsebool -P httpd_setrlimit=0
fi

%prep
%setup -q

%build
# Make sure the version in the spec file and the version used
# for building matches
fts_api_ver=`awk 'match($0, /^API_VERSION = dict\(major=([0-9]+), minor=([0-9]+), patch=([0-9]+)\)/, m) {print m[1]"."m[2]"."m[3]; }' src/fts3rest/fts3rest/controllers/api.py`
fts_spec_ver=`expr "%{version}" : '\([0-9]*\\.[0-9]*\\.[0-9]*\)'`
if [ "$fts_api_ver" != "$fts_spec_ver" ]; then
    echo "The version in the spec file does not match the api.py version!"
    echo "$fts_api_ver != %{version}"
    exit 1
fi

%cmake . -DCMAKE_INSTALL_PREFIX=/ -DPYTHON_SITE_PACKAGES=%{python2_sitelib}
make %{?_smp_mflags}

%if %{?fedora}%{!?fedora:0} < 28 || %{?rhel}%{!?rhel:0} >= 6
%check
pushd src/fts3rest
%if %{?fedora}%{!?fedora:0} >= 17 || %{?rhel}%{!?rhel:0} >= 7
PYTHONPATH=../ ./setup_pylons_plugin.py install --user
PYTHONPATH=../ nosetests --with-xunit --xunit-file=%{?nosetest_path}/nosetests.xml
%else
PYTHONPATH=../:/usr/lib64/python2.6/site-packages/SQLAlchemy-0.8.2-py2.6-linux-x86_64.egg/ \
    nosetests1.1 --with-xunit --xunit-file=%{?nosetest_path}/nosetests.xml
%endif
popd
%endif

%install
mkdir -p %{buildroot}
make install DESTDIR=%{buildroot}
%if %{?rhel}%{!?rhel:0} == 6
rm -rf %{buildroot}/%{_prefix}/lib/firewalld/services/fts3rest.xml
%endif
mkdir -p %{buildroot}/%{_var}/cache/fts3rest/
mkdir -p %{buildroot}/%{_var}/log/fts3rest/

cp --preserve=timestamps -r src/fts3 %{buildroot}/%{python2_sitelib}

cat > %{buildroot}/%{python2_sitelib}/fts3.egg-info <<EOF
Metadata-Version: 1.0
Name: fts3
Version: %{version}
Summary: FTS3 Python Libraries.
Home-page: http://fts3-service.web.cern.ch
Author: FTS Developers
Author-email: fts-devel@cern.ch
License: Apache2
EOF

%files
%dir %{python2_sitelib}/fts3rest/

%{python2_sitelib}/fts3rest.egg-info/*

%{python2_sitelib}/fts3rest/__init__.py*
%{python2_sitelib}/fts3rest/websetup.py*

%{python2_sitelib}/fts3rest/config/*.py*
%{python2_sitelib}/fts3rest/config/routing/__init__.py*
%{python2_sitelib}/fts3rest/config/routing/base.py*

%{python2_sitelib}/fts3rest/controllers/api.py*
%{python2_sitelib}/fts3rest/controllers/archive.py*
%{python2_sitelib}/fts3rest/controllers/autocomplete.py*
%{python2_sitelib}/fts3rest/controllers/banning.py*
%{python2_sitelib}/fts3rest/controllers/config/*.py*
%{python2_sitelib}/fts3rest/controllers/datamanagement.py*
%{python2_sitelib}/fts3rest/controllers/delegation.py*
%{python2_sitelib}/fts3rest/controllers/error.py*
%{python2_sitelib}/fts3rest/controllers/__init__.py*
%{python2_sitelib}/fts3rest/controllers/files.py*
%{python2_sitelib}/fts3rest/controllers/jobs.py*
%{python2_sitelib}/fts3rest/controllers/optimizer.py*
%{python2_sitelib}/fts3rest/controllers/serverstatus.py*

%{python2_sitelib}/fts3rest/lib/api/
%{python2_sitelib}/fts3rest/lib/app_globals.py*
%{python2_sitelib}/fts3rest/lib/base.py*
%{python2_sitelib}/fts3rest/lib/gfal2_wrapper.py*
%{python2_sitelib}/fts3rest/lib/heartbeat.py*
%{python2_sitelib}/fts3rest/lib/helpers/
%{python2_sitelib}/fts3rest/lib/http_exceptions.py*
%{python2_sitelib}/fts3rest/lib/__init__.py*
%{python2_sitelib}/fts3rest/lib/JobBuilder.py*
%{python2_sitelib}/fts3rest/lib/middleware/*.py*
%{python2_sitelib}/fts3rest/lib/middleware/fts3auth/*.py*
%{python2_sitelib}/fts3rest/lib/middleware/fts3auth/methods/__init__.py*
%{python2_sitelib}/fts3rest/lib/middleware/fts3auth/methods/ssl.py*
%{python2_sitelib}/fts3rest/lib/scheduler/schd.py*
%{python2_sitelib}/fts3rest/lib/scheduler/db.py*
%{python2_sitelib}/fts3rest/lib/scheduler/Cache.py*
%{python2_sitelib}/fts3rest/lib/scheduler/__init__.py*

%{python2_sitelib}/fts3rest/model/

%{python2_sitelib}/fts3rest/public/
%{python2_sitelib}/fts3rest/templates/delegation.html
%{python2_sitelib}/fts3rest/templates/config/

%{_libexecdir}/fts3
%config(noreplace) %{_sysconfdir}/fts3/fts3rest.ini
%config(noreplace) %{_sysconfdir}/httpd/conf.d/fts3rest.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/fts-rest
%dir %attr(0755,fts3,fts3) %{_var}/cache/fts3rest
%dir %attr(0755,fts3,fts3) %{_var}/log/fts3rest
%doc docs/README.md
%doc docs/install.md
%doc docs/api.md

%if %{?rhel}%{!?rhel:0} >= 7 || %{?fedora}%{!?fedora:0} >= 28
%files firewalld
%config(noreplace) %{_prefix}/lib/firewalld/services/fts3rest.xml
%endif

%files cloud-storage
%{python2_sitelib}/fts3rest/config/routing/cstorage.py*
%{python2_sitelib}/fts3rest/controllers/cloudStorage.py*
%{python2_sitelib}/fts3rest/controllers/CSdropbox.py*
%{python2_sitelib}/fts3rest/controllers/CSInterface.py*

%files oauth2
%{python2_sitelib}/fts3rest/config/routing/oauth2.py*
%{python2_sitelib}/fts3rest/controllers/oauth2.py*
%{python2_sitelib}/fts3rest/lib/oauth2lib/
%{python2_sitelib}/fts3rest/lib/oauth2provider.py*
%{python2_sitelib}/fts3rest/lib/middleware/fts3auth/methods/oauth2.py*
%{python2_sitelib}/fts3rest/templates/app.html
%{python2_sitelib}/fts3rest/templates/app_register.html
%{python2_sitelib}/fts3rest/templates/apps.html
%{python2_sitelib}/fts3rest/templates/authz_confirm.html
%{python2_sitelib}/fts3rest/templates/authz_failure.html
%{python2_sitelib}/fts3rest/templates/authz_noredirect.html

%files http-authz-signed-cert
%{python2_sitelib}/fts3rest/lib/middleware/fts3auth/methods/http.py*

%files cli
%{_bindir}/fts-rest-*
%config(noreplace) %{_sysconfdir}/fts3/fts3client.cfg
%{_mandir}/man1/fts-rest*

%files selinux

%if %{?fedora}%{!?fedora:0} >= 28
%files -n python2-fts
%else
%files -n python-fts
%endif
%{python2_sitelib}/fts3
%{python2_sitelib}/fts3.egg-info
%doc LICENSE

%changelog
* Tue Feb 26 2019 Alejandro Alvarez Ayllon <aalvarez@cern.ch> - 3.8.3-1
- Update for new upstream release

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 3.7.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Aug 23 2018 Peter Robinson <pbrobinson@fedoraproject.org> 3.7.1-3
- Build on ppc64le (all deps now present)
- Drop package groups

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.7.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org>
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Dec 17 2017 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl>
- Python 2 binary package renamed to python2-fts
  See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3

* Sat Aug 19 2017 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 3.6.3-3
- Python 2 binary package renamed to python2-fts-rest
  See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.6.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue Apr 18 2017 Alejandro Alvarez Ayllon <aalvarez@cern.ch> - 3.6.3-1
- Update for new upstream release

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.5.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Nov 15 2016 Alejandro Alvarez Ayllon <aalvarez@cern.ch> - 3.5.4-1
- Update for new upstream release

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-2
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Tue Apr 19 2016 Alejandro Alvarez Ayllon <aalvarez@cern.ch> - 3.4.0-1
- Update for new upstream release

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 3.3.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.32-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri Mar 13 2015 Alejandro Alvarez Ayllon <aalvarez@cern.ch> - 3.2.32-2
- Missing dependencies

* Fri Mar 13 2015 Alejandro Alvarez Ayllon <aalvarez@cern.ch> - 3.2.32-1
- Update for new upstream release

* Fri Aug 15 2014 Michal Simon <michal.simon@cern.ch> - 3.2.26-2
- Update for new upstream release

* Mon Jun 30 2014 Michal Simon <michal.simon@cern.ch> - 3.2.26-1
- First EPEL release

* Tue May 13 2014 Michal Simon <michal.simon@cern.ch> - 3.2.25-1
- Marging fts-rest and python-fts

* Mon Mar 10 2014 Alejandro Álvarez <aalvarez@cern.ch> - 3.2.0-1
- Creating log directory

* Fri Jan 03 2014 Alejandro Álvarez <aalvarez@cern.ch> - 3.1.0-1
- Major and minor versions follow FTS3

* Tue Aug 13 2013 Alejandro Álvarez <aalvarez@cern.ch> - 0.0.2-2
- Packaging /var/cache/fts3rest

* Tue Jul 02 2013 Alejandro Álvarez <aalvarez@cern.ch> - 0.0.1-9
- Introduced -selinux package

* Thu Mar 21 2013 Alejandro Álvarez <aalvarez@cern.ch> - 0.0.1-1
- Initial build
